Index: /palm/trunk/SOURCE/turbulence_closure_mod.f90
===================================================================
--- /palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 4509)
+++ /palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 4510)
@@ -1892,32 +1921,31 @@
 
     CONTAINS
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Calculate the shortest distance between position (i/j/k)=(0/0/0) and
-!> (pos_i/jj/kk), where (jj/kk) is the position of the maximum of 'array'
-!> closest to the origin (0/0) of 'array'.
-!------------------------------------------------------------------------------!
+!> Calculate the shortest distance between position (i/j/k)=(0/0/0) and (pos_i/jj/kk), where (jj/kk)
+!> is the position of the maximum of 'array' closest to the origin (0/0) of 'array'.
+!--------------------------------------------------------------------------------------------------!
     REAL(wp) FUNCTION shortest_distance( array, orientation, pos_i )
 
        IMPLICIT NONE
 
-       LOGICAL, INTENT(IN) :: orientation    !< flag if array represents an array oriented upwards (true) or downwards (false)
-
-       INTEGER(iwp), INTENT(IN) :: pos_i     !< x position of the yz-plane 'array'
-
-       INTEGER(iwp) :: a                     !< loop index
-       INTEGER(iwp) :: b                     !< loop index
-       INTEGER(iwp) :: jj                    !< loop index
-
-       INTEGER(KIND=1) :: maximum            !< maximum of array along z dimension
-
-       INTEGER(iwp), DIMENSION(0:rad_j) :: loc_k !< location of closest wall along vertical dimension
-
-       INTEGER(KIND=1), DIMENSION(0:rad_k+1,0:rad_j), INTENT(IN) :: array !< array containing a yz-plane at position pos_i
-
-!
-!--    Get coordinate of first maximum along vertical dimension
-!--    at each y position of array (similar to function maxloc but more stable).
+       INTEGER(iwp), INTENT(IN) ::  pos_i  !< x position of the yz-plane 'array'
+
+       INTEGER(iwp) ::  a   !< loop index
+       INTEGER(iwp) ::  b   !< loop index
+       INTEGER(iwp) ::  jj  !< loop index
+
+       INTEGER(KIND=1) ::  maximum  !< maximum of array along z dimension
+
+       INTEGER(iwp), DIMENSION(0:rad_j) ::  loc_k  !< location of closest wall along vertical dimension
+
+       INTEGER(KIND=1), DIMENSION(0:rad_k+1,0:rad_j), INTENT(IN) ::  array  !< array containing a yz-plane at position pos_i
+
+       LOGICAL, INTENT(IN) ::  orientation  !< flag if array represents an array oriented upwards (true) or downwards (false)
+
+!
+!--    Get coordinate of first maximum along vertical dimension at each y position of array
+!--    (similar to function maxloc but more stable).
        DO  a = 0, rad_j
           loc_k(a) = rad_k+1
@@ -1934,28 +1962,28 @@
        shortest_distance = radius
 !
-!--    Calculate distance between position (0/0/0) and
-!--    position (pos_i/jj/loc(jj)) and only save the shortest distance.
-       IF ( orientation ) THEN  !if array is oriented upwards
+!--    Calculate distance between position (0/0/0) and position (pos_i/jj/loc(jj)) and only save the
+!--    shortest distance.
+       IF ( orientation )  THEN  !if array is oriented upwards
           DO  jj = 0, rad_j
-             shortest_distance =                                               &
-                MIN( shortest_distance,                                        &
-                     SQRT( MAX(REAL(pos_i, KIND=wp)*dx-0.5_wp*dx, 0.0_wp)**2   &
-                         + MAX(REAL(jj, KIND=wp)*dy-0.5_wp*dy, 0.0_wp)**2      &
-                         + MAX(zw(loc_k(jj)+k-1)-zu(k), 0.0_wp)**2             &
-                         )                                                     &
-                   )
+             shortest_distance =                                                                   &
+               MIN( shortest_distance,                                                             &
+                    SQRT( MAX( REAL( pos_i, KIND = wp ) * dx - 0.5_wp * dx, 0.0_wp)**2             &
+                        + MAX( REAL( jj, KIND = wp ) * dy - 0.5_wp * dy, 0.0_wp)**2                &
+                        + MAX( zw(loc_k(jj)+k-1) - zu(k), 0.0_wp)**2                               &
+                        )                                                                          &
+                  )
           ENDDO
        ELSE  !if array is oriented downwards
           !> @note MAX within zw required to circumvent error at domain border
-          !>   At the domain border, if non-cyclic boundary is present, the
-          !>   index for zw could be -1, which will be errorneous (zw(-1) does
-          !>   not exist). The MAX function limits the index to be at least 0.
+          !>   At the domain border, if non-cyclic boundary is present, the index for zw could be
+          !>   -1, which will be errorneous (zw(-1) does not exist). The MAX function limits the
+          !>   index to be at least 0.
           DO  jj = 0, rad_j
-             shortest_distance =                                               &
-                MIN( shortest_distance,                                        &
-                     SQRT( MAX(REAL(pos_i, KIND=wp)*dx-0.5_wp*dx, 0.0_wp)**2   &
-                         + MAX(REAL(jj, KIND=wp)*dy-0.5_wp*dy, 0.0_wp)**2      &
-                         + MAX(zu(k)-zw(MAX(k-loc_k(jj),0_iwp)), 0.0_wp)**2    &
-                         )                                                     &
+             shortest_distance =                                                                   &
+                MIN( shortest_distance,                                                            &
+                     SQRT( MAX(REAL(pos_i, KIND=wp)*dx-0.5_wp*dx, 0.0_wp)**2                       &
+                         + MAX(REAL(jj, KIND=wp)*dy-0.5_wp*dy, 0.0_wp)**2                          &
+                         + MAX(zu(k)-zw(MAX(k-loc_k(jj),0_iwp)), 0.0_wp)**2                        &
+                         )                                                                         &
                    )
           ENDDO
@@ -1964,34 +1992,33 @@
     END FUNCTION
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Copy a subarray of size (kb:kt,js:jn,il:ir) centered around grid point
-!> (kp,jp,ip) containing the first bit of wall_flags_total_0 into the array
-!> 'vicinity'. Only copy first bit as this indicates the presence of topography.
-!------------------------------------------------------------------------------!
+!> Copy a subarray of size (kb:kt,js:jn,il:ir) centered around grid point (kp,jp,ip) containing the
+!> first bit of wall_flags_total_0 into the array 'vicinity'. Only copy first bit as this indicates
+!> the presence of topography.
+!--------------------------------------------------------------------------------------------------!
     SUBROUTINE copy_into_vicinity( kp, jp, ip, kb, kt, js, jn, il, ir )
 
        IMPLICIT NONE
 
-       INTEGER(iwp), INTENT(IN) :: il !< left loop boundary
-       INTEGER(iwp), INTENT(IN) :: ip !< center position in x-direction
-       INTEGER(iwp), INTENT(IN) :: ir !< right loop boundary
-       INTEGER(iwp), INTENT(IN) :: jn !< northern loop boundary
-       INTEGER(iwp), INTENT(IN) :: jp !< center position in y-direction
-       INTEGER(iwp), INTENT(IN) :: js !< southern loop boundary
-       INTEGER(iwp), INTENT(IN) :: kb !< bottom loop boundary
-       INTEGER(iwp), INTENT(IN) :: kp !< center position in z-direction
-       INTEGER(iwp), INTENT(IN) :: kt !< top loop boundary
-
-       INTEGER(iwp) :: i   !< loop index
-       INTEGER(iwp) :: j   !< loop index
-       INTEGER(iwp) :: k   !< loop index
+       INTEGER(iwp), INTENT(IN) ::  il  !< left loop boundary
+       INTEGER(iwp), INTENT(IN) ::  ip  !< center position in x-direction
+       INTEGER(iwp), INTENT(IN) ::  ir  !< right loop boundary
+       INTEGER(iwp), INTENT(IN) ::  jn  !< northern loop boundary
+       INTEGER(iwp), INTENT(IN) ::  jp  !< center position in y-direction
+       INTEGER(iwp), INTENT(IN) ::  js  !< southern loop boundary
+       INTEGER(iwp), INTENT(IN) ::  kb  !< bottom loop boundary
+       INTEGER(iwp), INTENT(IN) ::  kp  !< center position in z-direction
+       INTEGER(iwp), INTENT(IN) ::  kt  !< top loop boundary
+
+       INTEGER(iwp) ::  i  !< loop index
+       INTEGER(iwp) ::  j  !< loop index
+       INTEGER(iwp) ::  k  !< loop index
 
        DO  i = il, ir
           DO  j = js, jn
              DO  k = kb, kt
-                vicinity(k,j,i) = MERGE( 0, 1,               &
-                       BTEST( wall_flags_total_0(kp+k,jp+j,ip+i), 0 ) )
+                vicinity(k,j,i) = MERGE( 0, 1, BTEST( wall_flags_total_0(kp+k,jp+j,ip+i), 0 ) )
              ENDDO
           ENDDO
@@ -2003,39 +2030,37 @@
 
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Initialize virtual velocities used later in production_e.
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE production_e_init
 
-    USE arrays_3d,                                                             &
-        ONLY:  drho_air_zw, zu
-
-    USE control_parameters,                                                    &
+    USE arrays_3d,                                                                                 &
+        ONLY:  drho_air_zw,                                                                        &
+               zu
+
+    USE control_parameters,                                                                        &
         ONLY:  constant_flux_layer
 
-    USE surface_layer_fluxes_mod,                                              &
+    USE surface_layer_fluxes_mod,                                                                  &
         ONLY:  phi_m
 
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i      !< grid index x-direction
-    INTEGER(iwp) ::  j      !< grid index y-direction
-    INTEGER(iwp) ::  k      !< grid index z-direction
-    INTEGER(iwp) ::  m      !< running index surface elements
-
-    REAL(wp) ::  km_sfc     !< diffusion coefficient, used to compute virtual velocities
+    INTEGER(iwp) ::  i  !< grid index x-direction
+    INTEGER(iwp) ::  j  !< grid index y-direction
+    INTEGER(iwp) ::  k  !< grid index z-direction
+    INTEGER(iwp) ::  m  !< running index surface elements
+
+    REAL(wp) ::  km_sfc  !< diffusion coefficient, used to compute virtual velocities
 
     IF ( constant_flux_layer )  THEN
 !
-!--    Calculate a virtual velocity at the surface in a way that the
-!--    vertical velocity gradient at k = 1 (u(k+1)-u_0) matches the
-!--    Prandtl law (-w'u'/km). This gradient is used in the TKE shear
-!--    production term at k=1 (see production_e_ij).
-!--    The velocity gradient has to be limited in case of too small km
-!--    (otherwise the timestep may be significantly reduced by large
-!--    surface winds).
-!--    not available in case of non-cyclic boundary conditions.
+!--    Calculate a virtual velocity at the surface in a way that the vertical velocity gradient at
+!--    k = 1 (u(k+1)-u_0) matches the Prandtl law (-w'u'/km). This gradient is used in the TKE shear
+!--    production term at k=1 (see production_e_ij). The velocity gradient has to be limited in case
+!--    of too small km (otherwise the timestep may be significantly reduced by large surface winds).
+!--    Not available in case of non-cyclic boundary conditions.
 !--    Default surfaces, upward-facing
        !$OMP PARALLEL DO PRIVATE(i,j,k,m)
@@ -2048,27 +2073,20 @@
           k = surf_def_h(0)%k(m)
 !
-!--       Note, calculation of u_0 and v_0 is not fully accurate, as u/v
-!--       and km are not on the same grid. Actually, a further
-!--       interpolation of km onto the u/v-grid is necessary. However, the
+!--       Note, calculation of u_0 and v_0 is not fully accurate, as u/v and km are not on the same
+!--       grid. Actually, a further interpolation of km onto the u/v-grid is necessary. However, the
 !--       effect of this error is negligible.
-          km_sfc = kappa * surf_def_h(0)%us(m) * surf_def_h(0)%z_mo(m) /       &
+          km_sfc = kappa * surf_def_h(0)%us(m) * surf_def_h(0)%z_mo(m) /                           &
                    phi_m( surf_def_h(0)%z_mo(m) / surf_def_h(0)%ol(m) )
 
-          surf_def_h(0)%u_0(m) = u(k+1,j,i) + surf_def_h(0)%usws(m) *          &
-                                     drho_air_zw(k-1)               *          &
-                                     ( zu(k+1) - zu(k-1)    )       /          &
-                                     ( km_sfc  + 1.0E-20_wp )
-          surf_def_h(0)%v_0(m) = v(k+1,j,i) + surf_def_h(0)%vsws(m) *          &
-                                     drho_air_zw(k-1)               *          &
-                                     ( zu(k+1) - zu(k-1)    )       /          &
-                                     ( km_sfc  + 1.0E-20_wp )
-
-          IF ( ABS( u(k+1,j,i) - surf_def_h(0)%u_0(m) )  >                     &
-               ABS( u(k+1,j,i) - u(k-1,j,i)           )                        &
-             )  surf_def_h(0)%u_0(m) = u(k-1,j,i)
-
-          IF ( ABS( v(k+1,j,i) - surf_def_h(0)%v_0(m) )  >                     &
-               ABS( v(k+1,j,i) - v(k-1,j,i)           )                        &
-             )  surf_def_h(0)%v_0(m) = v(k-1,j,i)
+          surf_def_h(0)%u_0(m) = u(k+1,j,i) + surf_def_h(0)%usws(m) * drho_air_zw(k-1) *           &
+                                 ( zu(k+1) - zu(k-1) ) / ( km_sfc  + 1.0E-20_wp )
+          surf_def_h(0)%v_0(m) = v(k+1,j,i) + surf_def_h(0)%vsws(m) * drho_air_zw(k-1) *           &
+                                 ( zu(k+1) - zu(k-1) ) / ( km_sfc  + 1.0E-20_wp )
+
+          IF ( ABS( u(k+1,j,i) - surf_def_h(0)%u_0(m) ) > ABS( u(k+1,j,i) - u(k-1,j,i) ) )         &
+             surf_def_h(0)%u_0(m) = u(k-1,j,i)
+
+          IF ( ABS( v(k+1,j,i) - surf_def_h(0)%v_0(m) ) > ABS( v(k+1,j,i) - v(k-1,j,i) ) )         &
+             surf_def_h(0)%v_0(m) = v(k-1,j,i)
 
        ENDDO
@@ -2084,24 +2102,17 @@
           k = surf_def_h(1)%k(m)
 !
-!--       Note, calculation of u_0 and v_0 is not fully accurate, as u/v
-!--       and km are not on the same grid. Actually, a further
-!--       interpolation of km onto the u/v-grid is necessary. However, the
+!--       Note, calculation of u_0 and v_0 is not fully accurate, as u/v and km are not on the same
+!--       grid. Actually, a further interpolation of km onto the u/v-grid is necessary. However, the
 !--       effect of this error is negligible.
-          surf_def_h(1)%u_0(m) = u(k-1,j,i) - surf_def_h(1)%usws(m) *          &
-                                     drho_air_zw(k-1) *                        &
-                                     ( zu(k+1)    - zu(k-1)    )  /            &
-                                     ( km(k,j,i)  + 1.0E-20_wp )
-          surf_def_h(1)%v_0(m) = v(k-1,j,i) - surf_def_h(1)%vsws(m) *          &
-                                     drho_air_zw(k-1) *                        &
-                                     ( zu(k+1)    - zu(k-1)    )  /            &
-                                     ( km(k,j,i)  + 1.0E-20_wp )
-
-          IF ( ABS( surf_def_h(1)%u_0(m) - u(k-1,j,i) )  >                     &
-               ABS( u(k+1,j,i)           - u(k-1,j,i) )                        &
-             )  surf_def_h(1)%u_0(m) = u(k+1,j,i)
-
-          IF ( ABS( surf_def_h(1)%v_0(m) - v(k-1,j,i) )  >                     &
-               ABS( v(k+1,j,i)           - v(k-1,j,i) )                        &
-             )  surf_def_h(1)%v_0(m) = v(k+1,j,i)
+          surf_def_h(1)%u_0(m) = u(k-1,j,i) - surf_def_h(1)%usws(m) * drho_air_zw(k-1) *           &
+                                     ( zu(k+1) - zu(k-1) ) / ( km(k,j,i) + 1.0E-20_wp )
+          surf_def_h(1)%v_0(m) = v(k-1,j,i) - surf_def_h(1)%vsws(m) * drho_air_zw(k-1) *           &
+                                     ( zu(k+1) - zu(k-1) ) / (km(k,j,i) + 1.0E-20_wp )
+
+          IF ( ABS( surf_def_h(1)%u_0(m) - u(k-1,j,i) ) > ABS( u(k+1,j,i) - u(k-1,j,i) ) )         &
+             surf_def_h(1)%u_0(m) = u(k+1,j,i)
+
+          IF ( ABS( surf_def_h(1)%v_0(m) - v(k-1,j,i) ) > ABS( v(k+1,j,i) - v(k-1,j,i) ) )         &
+             surf_def_h(1)%v_0(m) = v(k+1,j,i)
 
        ENDDO
@@ -2117,27 +2128,20 @@
           k = surf_lsm_h%k(m)
 !
-!--       Note, calculation of u_0 and v_0 is not fully accurate, as u/v
-!--       and km are not on the same grid. Actually, a further
-!--       interpolation of km onto the u/v-grid is necessary. However, the
+!--       Note, calculation of u_0 and v_0 is not fully accurate, as u/v and km are not on the same
+!--       grid. Actually, a further interpolation of km onto the u/v-grid is necessary. However, the
 !--       effect of this error is negligible.
-          km_sfc = kappa * surf_lsm_h%us(m) * surf_lsm_h%z_mo(m) /             &
+          km_sfc = kappa * surf_lsm_h%us(m) * surf_lsm_h%z_mo(m) /                                 &
                    phi_m( surf_lsm_h%z_mo(m) / surf_lsm_h%ol(m) )
 
-          surf_lsm_h%u_0(m) = u(k+1,j,i) + surf_lsm_h%usws(m)    *             &
-                                        drho_air_zw(k-1)         *             &
-                                        ( zu(k+1) - zu(k-1)    ) /             &
-                                        ( km_sfc  + 1.0E-20_wp )
-          surf_lsm_h%v_0(m) = v(k+1,j,i) + surf_lsm_h%vsws(m)    *             &
-                                        drho_air_zw(k-1)         *             &
-                                        ( zu(k+1) - zu(k-1)    ) /             &
-                                        ( km_sfc  + 1.0E-20_wp )
-
-          IF ( ABS( u(k+1,j,i) - surf_lsm_h%u_0(m) )  >                        &
-               ABS( u(k+1,j,i) - u(k-1,j,i)   )                                &
-             )  surf_lsm_h%u_0(m) = u(k-1,j,i)
-
-          IF ( ABS( v(k+1,j,i) - surf_lsm_h%v_0(m) )  >                        &
-               ABS( v(k+1,j,i) - v(k-1,j,i)   )                                &
-             )  surf_lsm_h%v_0(m) = v(k-1,j,i)
+          surf_lsm_h%u_0(m) = u(k+1,j,i) + surf_lsm_h%usws(m) * drho_air_zw(k-1) *                 &
+                              ( zu(k+1) - zu(k-1) ) / ( km_sfc  + 1.0E-20_wp )
+          surf_lsm_h%v_0(m) = v(k+1,j,i) + surf_lsm_h%vsws(m) * drho_air_zw(k-1) *                 &
+                                        ( zu(k+1) - zu(k-1)) / ( km_sfc  + 1.0E-20_wp )
+
+          IF ( ABS( u(k+1,j,i) - surf_lsm_h%u_0(m) ) > ABS( u(k+1,j,i) - u(k-1,j,i) ) )            &
+             surf_lsm_h%u_0(m) = u(k-1,j,i)
+
+          IF ( ABS( v(k+1,j,i) - surf_lsm_h%v_0(m) ) > ABS( v(k+1,j,i) - v(k-1,j,i) ) )            &
+             surf_lsm_h%v_0(m) = v(k-1,j,i)
 
        ENDDO
@@ -2153,27 +2157,20 @@
           k = surf_usm_h%k(m)
 !
-!--       Note, calculation of u_0 and v_0 is not fully accurate, as u/v
-!--       and km are not on the same grid. Actually, a further
-!--       interpolation of km onto the u/v-grid is necessary. However, the
+!--       Note, calculation of u_0 and v_0 is not fully accurate, as u/v and km are not on the same
+!--       grid. Actually, a further interpolation of km onto the u/v-grid is necessary. However, the
 !--       effect of this error is negligible.
-          km_sfc = kappa * surf_usm_h%us(m) * surf_usm_h%z_mo(m) /             &
+          km_sfc = kappa * surf_usm_h%us(m) * surf_usm_h%z_mo(m) /                                 &
                    phi_m( surf_usm_h%z_mo(m) / surf_usm_h%ol(m) )
 
-          surf_usm_h%u_0(m) = u(k+1,j,i) + surf_usm_h%usws(m)    *             &
-                                        drho_air_zw(k-1)         *             &
-                                        ( zu(k+1) - zu(k-1)    ) /             &
-                                        ( km_sfc  + 1.0E-20_wp )
-          surf_usm_h%v_0(m) = v(k+1,j,i) + surf_usm_h%vsws(m)    *             &
-                                        drho_air_zw(k-1)         *             &
-                                        ( zu(k+1) - zu(k-1)    ) /             &
-                                        ( km_sfc  + 1.0E-20_wp )
-
-          IF ( ABS( u(k+1,j,i) - surf_usm_h%u_0(m) )  >                        &
-               ABS( u(k+1,j,i) - u(k-1,j,i)   )                                &
-             )  surf_usm_h%u_0(m) = u(k-1,j,i)
-
-          IF ( ABS( v(k+1,j,i) - surf_usm_h%v_0(m) )  >                        &
-               ABS( v(k+1,j,i) - v(k-1,j,i)   )                                &
-             )  surf_usm_h%v_0(m) = v(k-1,j,i)
+          surf_usm_h%u_0(m) = u(k+1,j,i) + surf_usm_h%usws(m) * drho_air_zw(k-1) *                 &
+                                        ( zu(k+1) - zu(k-1) ) / ( km_sfc  + 1.0E-20_wp )
+          surf_usm_h%v_0(m) = v(k+1,j,i) + surf_usm_h%vsws(m) * drho_air_zw(k-1) *                 &
+                                        ( zu(k+1) - zu(k-1) ) / ( km_sfc  + 1.0E-20_wp )
+
+          IF ( ABS( u(k+1,j,i) - surf_usm_h%u_0(m) ) > ABS( u(k+1,j,i) - u(k-1,j,i) ) )            &
+             surf_usm_h%u_0(m) = u(k-1,j,i)
+
+          IF ( ABS( v(k+1,j,i) - surf_usm_h%v_0(m) ) > ABS( v(k+1,j,i) - v(k-1,j,i) ) )            &
+             surf_usm_h%v_0(m) = v(k-1,j,i)
 
        ENDDO
@@ -2192,5 +2189,5 @@
 
 
-    CHARACTER (LEN=*) ::  location !<
+    CHARACTER(LEN=*) ::  location !<
 
 !    INTEGER(iwp) ::  i !<
@@ -2200,6 +2197,6 @@
 !
 !-- Here the module-specific actions follow
-!-- No calls for single grid points are allowed at locations before and
-!-- after the timestep, since these calls are not within an i,j-loop
+!-- No calls for single grid points are allowed at locations before and after the timestep, since
+!-- these calls are not within an i, j-loop
     SELECT CASE ( location )
 
@@ -2258,8 +2255,8 @@
 
 
-    CHARACTER (LEN=*) ::  location
-
-    INTEGER(iwp) ::  i
-    INTEGER(iwp) ::  j
+    CHARACTER(LEN=*) ::  location  !<
+
+    INTEGER(iwp) ::  i  !<
+    INTEGER(iwp) ::  j  !<
 
 !
@@ -2301,26 +2298,25 @@
 
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Prognostic equation for subgrid-scale TKE and TKE dissipation rate.
-!> Vector-optimized version
-!------------------------------------------------------------------------------!
+!> Prognostic equation for subgrid-scale TKE and TKE dissipation rate. Vector-optimized version
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE tcm_prognostic_equations
 
-    USE control_parameters,                                                    &
-        ONLY:  scalar_advec, tsc
+    USE control_parameters,                                                                        &
+        ONLY:  scalar_advec,                                                                       &
+               tsc
 
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i       !< loop index
-    INTEGER(iwp) ::  j       !< loop index
-    INTEGER(iwp) ::  k       !< loop index
-
-    REAL(wp)     ::  sbt     !< wheighting factor for sub-time step
-
-!
-!-- If required, compute prognostic equation for turbulent kinetic
-!-- energy (TKE)
+    INTEGER(iwp) ::  i  !< loop index
+    INTEGER(iwp) ::  j  !< loop index
+    INTEGER(iwp) ::  k  !< loop index
+
+    REAL(wp)     ::  sbt  !< wheighting factor for sub-time step
+
+!
+!-- If required, compute prognostic equation for turbulent kinetic energy (TKE)
     IF ( .NOT. constant_diffusion )  THEN
 
@@ -2354,9 +2350,8 @@
              IF ( timestep_scheme(1:5) == 'runge' )  THEN
                 IF ( ws_scheme_sca )  THEN
-                   CALL advec_s_ws( advc_flags_s, e, 'e',                      &
-                                    bc_dirichlet_l  .OR.  bc_radiation_l,      &
-                                    bc_dirichlet_n  .OR.  bc_radiation_n,      &
-                                    bc_dirichlet_r  .OR.  bc_radiation_r,      &
-                                    bc_dirichlet_s  .OR.  bc_radiation_s )
+                   CALL advec_s_ws( advc_flags_s, e, 'e', bc_dirichlet_l  .OR.  bc_radiation_l,    &
+                                                          bc_dirichlet_n  .OR.  bc_radiation_n,    &
+                                                          bc_dirichlet_r  .OR.  bc_radiation_r,    &
+                                                          bc_dirichlet_s  .OR.  bc_radiation_s )
                 ELSE
                    CALL advec_s_pw( e )
@@ -2389,7 +2384,6 @@
 !
 !--    Prognostic equation for TKE.
-!--    Eliminate negative TKE values, which can occur due to numerical
-!--    reasons in the course of the integration. In such cases the old TKE
-!--    value is reduced by 90%.
+!--    Eliminate negative TKE values, which can occur due to numerical reasons in the course of the
+!--    integration. In such cases the old TKE value is reduced by 90%.
        !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
        !$ACC PRESENT(e, tend, te_m, wall_flags_total_0) &
@@ -2398,13 +2392,9 @@
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             !following directive is required to vectorize on Intel19
+             !Following directive is required to vectorize on Intel19
              !DIR$ IVDEP
              DO  k = nzb+1, nzt
-                e_p(k,j,i) = e(k,j,i) + ( dt_3d * ( sbt * tend(k,j,i) +        &
-                                                 tsc(3) * te_m(k,j,i) )        &
-                                        )                                      &
-                                   * MERGE( 1.0_wp, 0.0_wp,                    &
-                                       BTEST( wall_flags_total_0(k,j,i), 0 )   &
-                                          )
+                e_p(k,j,i) = e(k,j,i) + ( dt_3d * ( sbt * tend(k,j,i) + tsc(3) * te_m(k,j,i) ) )   &
+                             * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
                 IF ( e_p(k,j,i) < 0.0_wp )  e_p(k,j,i) = 0.1_wp * e(k,j,i)
              ENDDO
@@ -2425,6 +2415,5 @@
                 ENDDO
              ENDDO
-          ELSEIF ( intermediate_timestep_count < &
-                   intermediate_timestep_count_max )  THEN
+          ELSEIF ( intermediate_timestep_count < intermediate_timestep_count_max )  THEN
              !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
              !$ACC PRESENT(tend, te_m)
@@ -2432,6 +2421,5 @@
                 DO  j = nys, nyn
                    DO  k = nzb+1, nzt
-                      te_m(k,j,i) =   -9.5625_wp * tend(k,j,i)                 &
-                                     + 5.3125_wp * te_m(k,j,i)
+                      te_m(k,j,i) = -9.5625_wp * tend(k,j,i) + 5.3125_wp * te_m(k,j,i)
                    ENDDO
                 ENDDO
@@ -2466,5 +2454,5 @@
 
 !
-!--    dissipation-tendency terms with no communication
+!--    Dissipation-tendency terms with no communication
        IF ( scalar_advec /= 'bc-scheme'  .OR.  use_upstream_for_tke )  THEN
           IF ( use_upstream_for_tke )  THEN
@@ -2475,8 +2463,8 @@
              IF ( timestep_scheme(1:5) == 'runge' )  THEN
                 IF ( ws_scheme_sca )  THEN
-                   CALL advec_s_ws( advc_flags_s, diss, 'diss',                &
-                                    bc_dirichlet_l  .OR.  bc_radiation_l,      &
-                                    bc_dirichlet_n  .OR.  bc_radiation_n,      &
-                                    bc_dirichlet_r  .OR.  bc_radiation_r,      &
+                   CALL advec_s_ws( advc_flags_s, diss, 'diss',                                    &
+                                    bc_dirichlet_l  .OR.  bc_radiation_l,                          &
+                                    bc_dirichlet_n  .OR.  bc_radiation_n,                          &
+                                    bc_dirichlet_r  .OR.  bc_radiation_r,                          &
                                     bc_dirichlet_s  .OR.  bc_radiation_s )
                 ELSE
@@ -2502,18 +2490,13 @@
 !
 !--    Prognostic equation for TKE dissipation.
-!--    Eliminate negative dissipation values, which can occur due to numerical
-!--    reasons in the course of the integration. In such cases the old
-!--    dissipation value is reduced by 90%.
+!--    Eliminate negative dissipation values, which can occur due to numerical reasons in the course
+!--    of the integration. In such cases the old dissipation value is reduced by 90%.
        DO  i = nxl, nxr
           DO  j = nys, nyn
              DO  k = nzb+1, nzt
-                diss_p(k,j,i) = diss(k,j,i) + ( dt_3d * ( sbt * tend(k,j,i) +  &
-                                                 tsc(3) * tdiss_m(k,j,i) )     &
-                                        )                                      &
-                                   * MERGE( 1.0_wp, 0.0_wp,                    &
-                                       BTEST( wall_flags_total_0(k,j,i), 0 )   &
-                                          )
-                IF ( diss_p(k,j,i) < 0.0_wp )                                  &
-                   diss_p(k,j,i) = 0.1_wp * diss(k,j,i)
+                diss_p(k,j,i) = diss(k,j,i) + ( dt_3d * ( sbt * tend(k,j,i) + tsc(3)               &
+                                                          * tdiss_m(k,j,i) ) )                     &
+                                * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
+                IF ( diss_p(k,j,i) < 0.0_wp )  diss_p(k,j,i) = 0.1_wp * diss(k,j,i)
              ENDDO
           ENDDO
@@ -2531,11 +2514,9 @@
                 ENDDO
              ENDDO
-          ELSEIF ( intermediate_timestep_count < &
-                   intermediate_timestep_count_max )  THEN
+          ELSEIF ( intermediate_timestep_count < intermediate_timestep_count_max )  THEN
              DO  i = nxl, nxr
                 DO  j = nys, nyn
                    DO  k = nzb+1, nzt
-                      tdiss_m(k,j,i) =   -9.5625_wp * tend(k,j,i)              &
-                                        + 5.3125_wp * tdiss_m(k,j,i)
+                      tdiss_m(k,j,i) = -9.5625_wp * tend(k,j,i) + 5.3125_wp * tdiss_m(k,j,i)
                    ENDDO
                 ENDDO
